#!/usr/bin/python
import signal
import os
import gobject
import gtk

def sizesort(s1, s2):
    try:
        a1 = apply (lambda x,y: x * y, map (int, s1.split("x")))
        a2 = apply (lambda x,y: x * y, map (int, s2.split("x")))
    except:
        return 0
    
    if a1 < a2:
        return -1
    if a1 == a2:
        return 0
    return 1

if __name__ == '__main__':
    signal.signal(signal.SIGINT, signal.SIG_DFL)


themedir = "."

sizedirs = []
for file in os.listdir(themedir):
    if os.path.isdir (themedir + "/" + file) and file != 'CVS':
        sizedirs.append(file)
sizedirs.sort (sizesort)

hash = {}
for dir in sizedirs:
    for file in os.listdir(themedir + "/" + dir):
        if file != 'CVS':
            hash[file] = 1

subdirs = hash.keys();
subdirs.sort()


headers = [gobject.TYPE_STRING]*2 + [gtk.gdk.Pixbuf]*len(sizedirs)
store = gtk.ListStore(*headers)

for category in subdirs:
    hash = {}
    for size in sizedirs:
        try:
            for file in os.listdir(themedir + "/" + size + "/" + category):
                hash[file] = 1
        except:
            pass
    icons = hash.keys()
    icons.sort()

    for icon in icons:
        iter = store.append()
        store.set_value(iter, 0, category)
        store.set_value(iter, 1, icon[:-4])
        for i in range(len(sizedirs)):
            try:
                file = themedir + "/" + sizedirs[i] + "/" + category + "/" + icon
                pixbuf = gtk.gdk.pixbuf_new_from_file (file)
                store.set_value(iter, 2+i, pixbuf)
            except:
                pass
        
                
        
view = gtk.TreeView(store)
column = gtk.TreeViewColumn("context", gtk.CellRendererText(), text=0)
column.set_resizable(1)
view.append_column(column)
column = gtk.TreeViewColumn("icon", gtk.CellRendererText(), text=1)
column.set_resizable(1)
view.append_column(column)
for i in range(len(sizedirs)):
    column = gtk.TreeViewColumn(sizedirs[i], gtk.CellRendererPixbuf(), pixbuf=2+i)
    column.set_resizable(1)
    view.append_column(column)

view.show()

scrolled = gtk.ScrolledWindow()
scrolled.add(view)
scrolled.show()

window = gtk.Window()

window.add(scrolled)
window.show()

gtk.main()
